codeforces 831C

来源:互联网 发布:唯一网络 编辑:程序博客网 时间:2024/05/17 05:10

Polycarp watched TV-show where k jury members one by one rated a participant by adding him a certain number of points (may be negative, i. e. points were subtracted). Initially the participant had some score, and each the marks were one by one added to his score. It is known that the i-th jury member gave ai points.

Polycarp does not remember how many points the participant had before this k marks were given, but he remembers that among the scores announced after each of the k judges rated the participant there were n (n ≤ k) values b1, b2, …, bn (it is guaranteed that all values bj are distinct). It is possible that Polycarp remembers not all of the scores announced, i. e. n < k. Note that the initial score wasn’t announced.

Your task is to determine the number of options for the score the participant could have before the judges rated the participant.

Input
The first line contains two integers k and n (1 ≤ n ≤ k ≤ 2 000) — the number of jury members and the number of scores Polycarp remembers.

The second line contains k integers a1, a2, …, ak ( - 2 000 ≤ ai ≤ 2 000) — jury’s marks in chronological order.

The third line contains n distinct integers b1, b2, …, bn ( - 4 000 000 ≤ bj ≤ 4 000 000) — the values of points Polycarp remembers. Note that these values are not necessarily given in chronological order.

Output
Print the number of options for the score the participant could have before the judges rated the participant. If Polycarp messes something up and there is no options, print “0” (without quotes).

Example
Input
4 1
-5 5 0 20
10
Output
3
Input
2 2
-2000 -2000
3998000 4000000
Output
1
Note
The answer for the first example is 3 because initially the participant could have  - 10, 10 or 15 points.

In the second example there is only one correct initial score equaling to 4 002 000.

题目大意:给出k个评委的评分,这些分数依次加到选手的原始分数上,在这个过程中,某人记得n(n<=k)个不同的分数(顺序不定),问原始分数有多少种可能?
解题思路(参考了大神的代码):首先将评委评分前缀和排序去重,得到的序列个数为答案可能的最大值(仔细想一下)。那么开始枚举每个原始成绩(即d=c[1]-b[i]),对每一个c[j]都要能够从d+某个前缀和得到,那么该原始成绩就符合条件,否则不符合。

#include <bits/stdc++.h>using namespace std;int num[2010],so[2010];int main(){    int k,n;    cin>>k>>n;    for(int i=1;i<=k;i++)    {        int x;        scanf("%d",&x);        num[i]=num[i-1]+x;    }    for(int i=1;i<=n;i++)    {        scanf("%d",&so[i]);    }    sort(num+1,num+k+1);    int len=unique(num+1,num+k+1)-num-1;    int ans=len;    for(int i=1;i<=len;i++)    {        int xx=so[1]-num[i];        for(int j=1;j<=n;j++)        {            if(!binary_search(num+1,num+len+1,so[j]-xx))            {                ans--;                break;            }        }    }    cout<<ans<<endl;}